<script setup lang="ts">
import { computed } from 'vue'
import { useI18n } from 'vue-i18n'
import CustomLoading from './custom-loading.vue'
import { usePersonalAppConfigStore } from '@/store/modules/personal-app-config'
import MarkdownRender from '@/components/markdown-render/markdown-render.vue'
import { useUserStore } from '@/store/modules/user'

interface Props {
  role: 'user' | 'assistant'
  messageItem: ConversationMessageItem
}

const props = defineProps<Props>()

const emit = defineEmits<{
  audioPlay: []
  audioPause: []
}>()

const { t } = useI18n()

const userStore = useUserStore()
const personalAppConfigStore = usePersonalAppConfigStore()

const useAvatar = computed(() => {
  return userStore.userInfo.avatarUrl || 'https://gsst-poe-sit.gz.bcebos.com/data/20240910/1725952917468.png'
})

const assistantAvatar = computed(() => {
  return personalAppConfigStore.baseInfo.agentAvatar
})

const isShowAudioControl = computed(() => {
  return props.role === 'assistant' && !props.messageItem.isVoiceLoading
})

const isPlayableAudio = computed(() => {
  return isShowAudioControl.value && !!props.messageItem.voiceFragmentUrlList.length
})

const isShowVoiceLoading = computed(() => {
  return props.role === 'assistant' && props.messageItem.isVoiceLoading && props.messageItem.isVoiceEnabled
})

function handleAudioControl() {
  if (!isPlayableAudio.value) {
    return
  }

  if (props.messageItem.isVoicePlaying) {
    emit('audioPause')
  } else {
    emit('audioPlay')
  }
}
</script>

<template>
  <div class="mb-5 flex last:mb-0">
    <NImage
      :src="role === 'user' ? useAvatar : assistantAvatar"
      preview-disabled
      :width="32"
      :height="32"
      object-fit="cover"
      class="mr-2 mt-1.5 h-8 w-8 flex-shrink-0 rounded-full"
    />

    <div class="flex flex-col items-start">
      <div
        class="min-w-[80px] max-w-full flex-wrap rounded-xl border border-[#e8e9eb] px-4 py-[11px]"
        :class="role === 'user' ? 'bg-[#4b87ff] text-white' : 'bg-white text-[#333]'"
      >
        <div v-if="messageItem.isTextContentLoading" class="py-1.5 pl-4">
          <CustomLoading />
        </div>

        <div v-else>
          <p class="break-all">
            <MarkdownRender
              :raw-text-content="
                messageItem.isEmptyContent
                  ? t('common_module.dialogue_module.empty_message_content')
                  : messageItem.textContent
              "
              :color="role === 'user' ? '#fff' : '#192338'"
            />
          </p>

          <div v-show="role === 'assistant' && messageItem.isAnswerResponseLoading" class="mb-[5px] mt-4 px-4">
            <CustomLoading />
          </div>
        </div>
      </div>

      <div
        v-show="isShowAudioControl"
        class="text-font-color flex items-center gap-0.5"
        :class="isPlayableAudio ? 'hover:text-theme-color cursor-pointer hover:opacity-80' : 'cursor-not-allowed'"
        @click="handleAudioControl"
      >
        <i v-if="!messageItem.isVoicePlaying" class="iconfont icon-play text-[24px]" />
        <div v-else class="mx-1.5 my-3 h-[12px] w-[12px] bg-[url(@/assets/images/playing.gif)] bg-[length:100%_100%]" />

        <span
          v-show="isPlayableAudio"
          class="text-[12px]"
          :class="messageItem.isVoicePlaying ? 'text-theme-color' : ''"
        >
          {{ messageItem.isVoicePlaying ? t('common_module.stop_playing') : t('common_module.start_playing') }}
        </span>
        <n-popover style="max-width: 310px">
          <template #trigger>
            <span v-show="!isPlayableAudio" class="text-[12px]"> {{ t('common_module.unplayable') }} </span>
          </template>
          {{ t('common_module.unplayable_tip') }}
        </n-popover>
      </div>

      <div v-if="isShowVoiceLoading" class="py-3.5 pl-6">
        <CustomLoading />
      </div>
    </div>
  </div>
</template>
